This folder contains Kubernetes manifest files and how-to guide for `OSDU Policy service` with Istio Service Mesh.

## Prerequisites
To access the Policy API, you need to be in the entitlements groups (service.policy.user, service.policy.admin).

Manifest require kubernetes namespace - osdu.
Istio sidecar injection should be enabled for osdu namespace.
```
$ kubectl create ns osdu
$ kubectl label namespace osdu istio-injection=enabled
```

## Deploy and Verify Policy Service
Deploy the Policy deployments, services, and virtual-services for Istio.

Use `--set` to provide appropriate image for Policy service

```
$ cd <helm chart directory>
$ helm install policy . --create-namespace --set imageRegistry="community.opengroup.org:5555/osdu/platform/security-and-compliance/policy:latest" -f values-osdu-gcp.yaml -n osdu
```
