package psc
import input.input
import data.agreement_v1.agreement_name

user_name := "trudy@bigoil.com"
# user_name := "joe@bigoil.com"
osdu_data_steward :="OSDU Data Steward"
# Data type A
third_party_data := "Third Party Data"
client_data := "Client Data"

# Data type B
Proprietary :="Proprietary"
Owned :="Owned"
# Data type C
Derivative :="Derivative"
# user_name := "John@bigoil.com"




# Test[input.record.DataSourceOrganisationID[j]]
# {
#   input.record.DataSourceOrganisationID[_] 
#     ==input.user.OrganisationBusinessUnit[_]
# }

# # default 
default check_PSC_user_access=false
default is_data_steward_role =false
# Test1[ input.legaltags.contractId]
# {
#   true
#   input.record.legal.legaltags[_] == input.legaltags.contractId
#   # agreement_name.agreement[input.legaltags.name[0]].
# # input.legaltags[input.record.legal.legaltags[_]].properties.dataType = third_party_data
#   # input.record.acl[input.user.osdurole][_] == input.group[_]
# }

#------------------------------
# Check if the user is part of the business unit and not a Data Steward
# and this will return true
#------------------------------
check_PSC_user_access=true{
    current_datetime := time.now_ns()

    # Check user is not data steward
    not validate_osdu_role(input.user.osdurole)

    # usergroup_validation
     input.record.acl[input.user.osdurole][_] == input.group[_]

    # # Check if record legal tag matches with legal tag list
     input.record.legal.legaltags[_]==input.legaltags.name[0]

    # # Check if agreement type is PSC
     agreement_name.agreement[input.record.legal.legaltags[_]].AgreementTypeID =="PSC"

    # # Check if array is empty
     count(check_user_org_access) > 0

    # # Validate Contract date
     current_datetime > time.parse_rfc3339_ns(agreement_name.agreement[input.legaltags.name[0]].EffectiveDate)
     current_datetime < time.parse_rfc3339_ns(agreement_name.agreement[input.legaltags.name[0]].TerminationDate)

    # Validate Agreement ID
     count(validate_agreement_ID) > 0
}

#-------------------------------------------------------------
# Check if the first rule check_PSC_user_access failed then user is a Data Steward
#-------------------------------------------------------------
check_PSC_user_access=true{

    # usergroup_validation
      validate_osdu_role(input.user.osdurole)    

     #Check if agreement type is PSC - ############-NOT REQUIRED for Data Steward ############
    #  data.agreement[data.legaltags[data.results[i].legal.legaltags[j]].properties.contractId].AgreementTypeID ="PSC"

     #Check if array is empty - ############-NOT REQUIRED for Data Steward ############
     #count(check_user_org_access) > 0

     #Validate Contract date - ############-NOT REQUIRED for Data Steward ############
    #  validate_start_terminate_date

     #Validate Agreement ID - ############-NOT REQUIRED for Data Steward ############
    #  count(validate_agreement_ID) > 0
}

is_data_steward_role=true
{
  validate_osdu_role(input.user.osdurole)
}

# Validate OSDU role and check for osdu data steward
validate_osdu_role(osdu_role)
{
  # true
  osdu_role == osdu_data_steward
}

# default validate_start_terminate_date =false
#Validate PSC start & end date with current date 
# validate_Agreement_date(effective_date,termination_date)
# {
#   current_time := time.now_ns()
#   current_time > time.parse_rfc3339_ns(effective_date)
#   current_time < time.parse_rfc3339_ns(termination_date)
# }

# Default check_user_org_access=false
# Check Data Orgnaization ID with User Orginazation ID
check_user_org_access[input.record.DataSourceOrganisationID[_]]
{
  # Validate Org business unit
   input.record.DataSourceOrganisationID[_] 
    ==input.user.OrganisationBusinessUnit[_]
}


# Validate Legal tag Contract ID with Agreement ID for all user except Data Steward
# Validate Third party data which require contract id and expiration date
# Validate Client data which require contract id and expiration date
validate_agreement_ID[input.legaltags.contractId]
{
    
    # Check legal Contract id has a match with agreement contract ID
    input.record.legal.legaltags[_] == input.legaltags.contractId
    agreement_name.agreement[input.record.legal.legaltags[_]]

    # Check data type "Third Part data" or "Client Data"
    Check_data_type

   
}

# Validate Legal tag Contract ID with Agreement ID for Data Steward
validate_agreement_ID[input.legaltags.contractId]
{
    
    input.record.legal.legaltags[_] == input.legaltags.contractId
    agreement_name.agreement[input.record.legal.legaltags[_]]
}

default Check_data_type=false

# Validate if the data type is "Third party data" 
Check_data_type=true
{
  input.legaltags.dataType = third_party_data
   # Check agreement expiration date for 3rd party data
    not is_legaltag_expired
}

# Validate if the data type is "Client data"
Check_data_type=true
{
  input.legaltags.dataType = client_data

   # Check agreement expiration date
    not is_legaltag_expired
}

# Validate if the data type is "Proprietary"
Check_data_type=true
{
  input.legaltags.dataType = Proprietary
}

# Validate if the data type is "Derivative"
Check_data_type=true
{
  input.legaltags.dataType = Derivative
}

# Validate if the data type is "Owned"
Check_data_type=true
{
  input.legaltags.dataType = Owned
}

default is_legaltag_expired=false
# Validate legal tag expiration date 
is_legaltag_expired =true
{
    current_time := time.now_ns()
    current_time > time.parse_rfc3339_ns(input.legaltags.expirationDate)
}

# validate_agreement_ID[data.legaltags[data.results[i].legal.legaltags[j]].properties.contractId]
# {
#     data.legaltags[data.results[i].legal.legaltags[j]].properties.contractId
#     validate_osdu_role

# }

