# Policy service tests

This describes how to tests bundle based dynamic policies. Postman collection for these tests is [Bundle_based_dynamic_policies_tests.postman_collection.json](Bundle_based_dynamic_policies_tests.postman_collection.json)

## Prerequisites
Test collection is separated in two folders: _Policy service_ and _Storage integration_. 
- For tests in _Policy service_, CSP needs to support bundles in policy service and has set _USE_BUNDLES_ environmental variable for policy service.

- For tests in _Storage integration_, CSP additionally transitioned storage service to use dynamic policies by [setting application properties in storage service](https://community.opengroup.org/osdu/platform/system/storage/-/blob/master/docs/tutorial/PolicyService-Integration.md).

To execute the tests, user must be member of _service.policy.admin_ group.

## Variables for Postman collection 
Following variables need to be set:
- _osdu_environment_url_ - URL of the OSDU instance to be tested
- _data_partition_id_ - Data partition to be tested
- _entitlements_group_domain_ - Domain used for groups in entitlements service
- _request_token_ - Bearer access token to be used for requests

## Not yet supported 
Dynamic policies can be used for data authorization in storage and in all other services that internally use storage. The remaining gap is for the same policies to enforce data authorization in search. This is ongoing work and is expected to be completed in next release.

Bundle_based_dynamic_policies_tests_M14.postman_collection.json has been updated for M14 (fastAPI and new changes to policy service)
